/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _CONFIGURE_CELL_RENDERER_H
#define _CONFIGURE_CELL_RENDERER_H

#include <gtk/gtk.h>

#define CONFIGURE_CELL_RENDERER_TYPE            (configure_cell_renderer_get_type ())
#define CONFIGURE_CELL_RENDERER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIGURE_CELL_RENDERER_TYPE, ConfigureCellRenderer))
#define CONFIGURE_CELL_RENDERER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIGURE_CELL_RENDERER_TYPE, ConfigureCellRendererClass))
#define IS_CONFIGURE_CELL_RENDERER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIGURE_CELL_RENDERER_TYPE))
#define IS_CONFIGURE_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIGURE_CELL_RENDERER_TYPE))
#define CONFIGURE_CELL_RENDERER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIGURE_CELL_RENDERER_TYPE, ConfigureCellRendererClass))

typedef struct _ConfigureCellRenderer ConfigureCellRenderer;
typedef struct _ConfigureCellRendererClass ConfigureCellRendererClass;

struct _ConfigureCellRenderer
{
  GtkCellRenderer parent;

  /*< private >*/
  gchar *value;
  GType type;
  GtkCellRenderer *text_renderer;
  GtkCellRenderer *toggle_renderer;
};

struct _ConfigureCellRendererClass
{
  GtkCellRendererClass parent_class;
  
  void (*changed) (ConfigureCellRenderer *renderer,
                   gchar *path,
                   gchar *value);
  gboolean (*check_writable) (ConfigureCellRenderer *renderer,
                              char *path);  
};

GType           configure_cell_renderer_get_type   (void);
GtkCellRenderer *configure_cell_renderer_new       (void);


#endif /* _CONFIGURE_CELL_RENDERER_H */
