/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _GPT_H
#define _GPT_H

#include <glib-object.h>
#include <gconf/gconf-client.h>
#include "main_window.h"

#define GPT_APP_TYPE			(gpt_app_get_type ())
#define GPT_APP(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GPT_APP_TYPE, GptApp))
#define GPT_APP_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GPT_APP_TYPE, GptAppClass))
#define GPT_IS_APP(obj)			(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPT_APP_TYPE))
#define GPT_IS_APP_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GPT_APP_TYPE))
#define GPT_APP_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GPT_APP_TYPE, GptAppClass))

typedef struct _gpt_app GptApp;
typedef struct _gpt_app_class GptAppClass;

struct _gpt_app {
	GObject parent;
	GptMainWindow *main_window;
	GConfClient *client;
	
	//gboolean run_as_root;
	gboolean need_auth;
	gchar *root_password; /* b3w4r3 0f d4 133t h4x0rz ;) */
};

struct _gpt_app_class {
	GObjectClass parent;
};

GType gpt_app_get_type (void);

#endif /* _GPT_H */
