/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _PROGRESS_WINDOW_H
#define _PROGRESS_WINDOW_H

#include <vte/vte.h>
#include <vte/reaper.h>

#define GPT_BUILD_DIR "/tmp/gnome-pkgtool-XXXXXX"

typedef struct _gpt_pw GptProgressWindow;
typedef struct _gpt_pw_class GptProgressWindowClass;
typedef struct _gpt_pw_private GptProgressWindowPriv;
	
#define GPT_PROGRESS_WINDOW_TYPE		(gpt_progress_window_get_type ())
#define GPT_PROGRESS_WINDOW(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GPT_PROGRESS_WINDOW_TYPE, GptProgressWindow))
#define GPT_PROGRESS_WINDOW_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GPT_PROGRESS_WINDOW_TYPE, GptProgressWindowClass))
#define GPT_IS_PROGRESS_WINDOW(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPT_PROGRESS_WINDOW_TYPE))
#define GPT_IS_PROGRESS_WINDOW_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GPT_PROGRESS_WINDOW_TYPE))
#define GPT_PROGRESS_WINDOW_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GPT_PROGRESS_WINDOW_TYPE, GptProgressWindowClass))

struct _gpt_pw_private
{
  GtkWidget *label;
  GtkWidget *exp;
  GtkWidget *adj;
      
  GtkWidget *btn_close;
  GtkWidget *btn_cancel;
  GtkWidget *details;
  GtkWidget *details_frame;
  GtkTextBuffer *details_buffer;
	
  VteTerminal *vte;
  VteReaper *reaper;
	
  pid_t pid;
  int log_fd;
  gchar *temp_dir;
  gboolean auth_done;

  gchar *complete_msg;
  gchar *aborted_msg;
  gchar *failed_msg;
};

struct _gpt_pw
{
  GtkWindow parent;
  GptProgressWindowPriv *priv;
};

struct _gpt_pw_class
{
  GtkWindowClass parent;
};

GType gpt_progress_window_get_type (void);
GtkWidget *gpt_progress_window_new ();

void gpt_progress_window_run (GptProgressWindow *pw, const gchar *cmd);

#endif /* _PROGRESS_WINDOW_H */
