#include <gtk/gtk.h>
#include "treeview.h"

/* There is no standard GtkTreeModel operation to iterate backwards,
 * so we implement one ourselves by converting to a GtkTreePath and back. */
gboolean
tree_model_iter_prev (GtkTreeModel *model, GtkTreeIter  *iter) {
	GtkTreePath *path;
	gboolean result;
  
	path = gtk_tree_model_get_path (model, iter);
	result = gtk_tree_path_prev (path);
	gtk_tree_model_get_iter (model, iter, path);
	gtk_tree_path_free (path);
 
	return result;
}

/* Helper function to get a GtkTreeIter pointing to the last row in a flat GtkTreeModel */
gboolean
tree_model_last_iter (GtkTreeModel *model, GtkTreeIter  *iter) {
	if (!gtk_tree_model_get_iter_first (model, iter))
		return FALSE;
  
	while (TRUE) {
		GtkTreeIter next = *iter;
		if (gtk_tree_model_iter_next (model, &next))
			*iter = next;
		else
			break;
	}
  
	return TRUE;
}
